{$S-,D-
	Window Manager
        by Sergey Kasandrov, June 94.
	Public Domain.
}

Unit TWin;

Interface

uses CRT, TCRT;

type

{  ࠬ  }
   FrameChars = array[1..8] of Char;

{ ਯ  }
   WinDesPtr = ^WinDescriptor;

   WinDescriptor = record
      Next: WinDesPtr;
      WinMin,
      WinMax,
      Shift: Word;
      Buffer,
      ShadeBuf: Pointer;
   end;

const

   SingleFrame = 1;
   DoubleFrame = 2;

{ ⠭   ࠬ }
   SingleChars: FrameChars = 'Ŀ';
   DoubleChars: FrameChars = 'ͻͼ';

var
   WinShift: Word;
   WinStack: WinDesPtr;
   WinHead:  Pointer;

{ 蠥  뢮, ࠭   ZoomWin }
procedure SqueezeWin(N: Word);

{ ⠭ ࠧ  }
procedure ZoomWin;

{  ࠬ  㬥蠥  뢮  ࠧ ࠬ }
procedure FrameWin(Fr, Attr: Byte);

{ 뢠   }
procedure OpenWin(X1, Y1, X2, Y2: Byte);

{    ࠭ }
procedure CloseWin;

{ ६饭 /  ᯨ    ⨢樥 }
procedure FreezeWin;
procedure ActivateWin;

{  ⥭   }
procedure ShadeWin(Attr: Byte);

{  }
procedure WaitKey(Mess: String);
procedure OpenFootWin( Norm, High: Byte);
procedure FootNote( N: Byte; St: String);

Implementation

{$L SQWIN   } procedure SqueezeWin; external;
{$L ZOOMWIN } procedure ZoomWin; external;

procedure FrameWin;
   var
      W, H, Y: Word;
      Frame: FrameChars;

   begin
      if Fr=1 then Frame:= SingleChars;
      if Fr=2 then Frame:= DoubleChars;
      W := Lo(WindMax) - Lo(WindMin) + 1;
      H := Hi(WindMax) - Hi(WindMin) + 1;
      WriteChar(1, 1, 1, Frame[1], Attr);
      WriteChar(2, 1, W - 2, Frame[2], Attr);
      WriteChar(W, 1, 1, Frame[3], Attr);
      for Y := 2 to H - 1 do begin
         WriteChar(1, Y, 1, Frame[4], Attr);
         WriteChar(W, Y, 1, Frame[5], Attr);
      end;
      WriteChar(1, H, 1, Frame[6], Attr);
      WriteChar(2, H, W - 2, Frame[7], Attr);
      WriteChar(W, H, 1, Frame[8], Attr);
      SqueezeWin($0101);
   end;

procedure SwapWin;
   var
      Save: Word;
      P: WinDesPtr;

   begin
      P:= WinStack;
      Save:= WindMin;
      WindMin:= P^.WinMin;
      P^.WinMin:= Save;
      Save:= WindMax;
      WindMax:= P^.WinMax;
      P^.WinMax:= Save;
      Save:= WinShift;
      WinShift:= P^.Shift;
      P^.Shift:= Save;
   end;


procedure FreezeWin;
   var P: WinDesPtr;

   begin
      P:= @WinHead;
      while P^.Next<>WinStack do P:= P^.Next;
      SwapWin;
      WinStack:= P;
   end;

procedure ActivateWin;
   begin
      WinStack:= WinStack^.Next;
      SwapWin;
   end;

procedure OpenWin(X1, Y1, X2, Y2: Byte);
   var P: WinDesPtr;

   begin

{ 塞  㧥 }
      P:= WinStack;
      New(WinStack);
      WinStack^.Next:= P^.Next;
      P^.Next:= WinStack;
      with WinStack^ do begin;
         WinMin:= WindMin;
         WinMax:= WindMax;
         Shift:= WinShift;
         ShadeBuf:= Nil;

{ ⠭  ⨢  }
         Window(X1, Y1, X2, Y2);
         GetMem(Buffer, WinSize);
         ReadWin(Buffer^);
      end;
      WinShift:=0;
   end;

procedure ShadeWin(Attr: Byte);
   var Save,
       Size : Word;

   begin
      Save:= WinShift;
      ZoomWin;
      with WinStack^ do begin
         GetMem(ShadeBuf, ShadeSize);
         ReadShade(ShadeBuf^);
      end;
      Size:= WindMax-WindMin+$101;
      FillBox(Succ(Lo(Size)), 2, Lo(Size+2), Hi(Size), Attr);
      FillBar(3, Succ(Hi(Size)), Lo(Size), Attr);
      SqueezeWin(Save);
   end;

procedure CloseWin;
   var P: WinDesPtr;

   begin
      ZoomWin;
      with WinStack^ do begin
         WriteWin(Buffer^);
         if ShadeBuf<>Nil then begin
            WriteShade(ShadeBuf^);
            FreeMem(ShadeBuf, ShadeSize);
         end;
         FreeMem(Buffer, WinSize);
         WindMin:= WinMin;
         WindMax:= WinMax;
         WinShift:= Shift;
      end;
      P:= @WinHead;
      while P^.Next<>WinStack do P:= P^.Next;
      P^.Next:= WinStack^.Next;
      Dispose(WinStack);
      WinStack:= P;
   end;

procedure WaitKey;
   var StLen: Byte absolute Mess;

   begin
      OpenWin( 70-StLen, 4, 75, 6);
      FillWin(' ', WhiteOnBrown);
      SqueezeWin( 1);
      FrameWin( 2, WhiteOnBrown);
      ShadeWin(DkGrayOnBlack);
      WrStr( 2, 1, Mess);
      WashBuffer; repeat until KeyPressed;
      if NextKeyWord=Esc then GetKeyWord;
      CloseWin;
   end;

procedure OpenFootWin;
   begin
      OpenWin( 1, 25, 80, 25);
      FillWin( ' ', Norm);
      WriteStr( 1,  1,  '1', High);
      WriteStr( 8,  1, ' 2', High);
      WriteStr( 16, 1, ' 3', High);
      WriteStr( 24, 1, ' 4', High);
      WriteStr( 32, 1, ' 5', High);
      WriteStr( 40, 1, ' 6', High);
      WriteStr( 48, 1, ' 7', High);
      WriteStr( 56, 1, ' 8', High);
      WriteStr( 64, 1, ' 9', High);
      WriteStr( 72, 1, ' 10', High);
   end;

procedure FootNote;
   begin
      WrStr( (Pred(N) shl 3)+2, 1, St);
   end;

begin
   WinShift:= 0;
   WinHead:= Nil;
   WinStack:= @WinHead;
end.
